clang 10.0.0git

Macros | Functions
USRGeneration.cpp File Reference
`#include "clang/Index/USRGeneration.h"`
`#include "clang/AST/ASTContext.h"`
`#include "clang/AST/Attr.h"`
`#include "clang/AST/DeclTemplate.h"`
`#include "clang/AST/DeclVisitor.h"`
`#include "clang/Lex/PreprocessingRecord.h"`
`#include "llvm/Support/Path.h"`
`#include "llvm/Support/raw_ostream.h"`
`#include "clang/AST/BuiltinTypes.def"`
`#include "clang/Basic/OpenCLImageTypes.def"`
`#include "clang/Basic/OpenCLExtensionTypes.def"`
`#include "clang/Basic/AArch64SVEACLETypes.def"`
Include dependency graph for USRGeneration.cpp:

Go to the source code of this file.

## Macros
#define | BUILTIN_TYPE(Id, SingletonId)
#define | PLACEHOLDER_TYPE(Id, SingletonId) case BuiltinType::Id:
#define | IMAGE_TYPE(ImgType, Id, SingletonId, Access, Suffix) case BuiltinType::Id:
#define | EXT_OPAQUE_TYPE(ExtType, Id, Ext) case BuiltinType::Id:
#define | SVE_TYPE(Name, Id, SingletonId) case BuiltinType::Id:

## Functions
static bool | printLoc (llvm::raw_ostream &OS, SourceLocation Loc, const SourceManager &SM, bool IncludeOffset)
static StringRef | GetExternalSourceContainer (const NamedDecl *D)
static void | printQualifier (llvm::raw_ostream &Out, ASTContext &Ctx, NestedNameSpecifier *NNS)
static void | combineClassAndCategoryExtContainers (StringRef ClsSymDefinedIn, StringRef CatSymDefinedIn, raw_ostream &OS)

## Macro Definition Documentation

## ◆ BUILTIN_TYPE

#define BUILTIN_TYPE | ( |  | Id,
|  |  | SingletonId
| ) |  |

## ◆ EXT_OPAQUE_TYPE

#define EXT_OPAQUE_TYPE | ( |  | ExtType,
|  |  | Id,
|  |  | Ext
| ) |  | case BuiltinType::Id:

## ◆ IMAGE_TYPE

#define IMAGE_TYPE | ( |  | ImgType,
|  |  | Id,
|  |  | SingletonId,
|  |  | Access,
|  |  | Suffix
| ) |  | case BuiltinType::Id:

## ◆ PLACEHOLDER_TYPE

#define PLACEHOLDER_TYPE | ( |  | Id,
|  |  | SingletonId
| ) |  | case BuiltinType::Id:

## ◆ SVE_TYPE

#define SVE_TYPE | ( |  | Name,
|  |  | Id,
|  |  | SingletonId
| ) |  | case BuiltinType::Id:

## Function Documentation

## ◆ combineClassAndCategoryExtContainers()

static void combineClassAndCategoryExtContainers | ( | StringRef | ClsSymDefinedIn,
|  | StringRef | CatSymDefinedIn,
|  | raw_ostream & | OS
| ) |  |
| static

Definition at line 1008 of file USRGeneration.cpp.

## ◆ GetExternalSourceContainer()

static StringRef GetExternalSourceContainer | ( | const NamedDecl * | D | ) |
| static

Definition at line 49 of file USRGeneration.cpp.

References clang::Decl::getExternalSourceSymbolAttr().

## ◆ printLoc()

static bool printLoc | ( | llvm::raw_ostream & | OS,
|  | SourceLocation | Loc,
|  | const SourceManager & | SM,
|  | bool | IncludeOffset
| ) |  |
| static

Returns
  true on error.

Definition at line 26 of file USRGeneration.cpp.

References clang::SourceManager::getDecomposedLoc(), clang::SourceManager::getExpansionLoc(), clang::SourceManager::getFileEntryForID(), clang::FileEntry::getName(), and clang::SourceLocation::isInvalid().

Referenced by clang::index::generateUSRForMacro().

## ◆ printQualifier()

static void printQualifier | ( | llvm::raw_ostream & | Out,
|  | ASTContext & | Ctx,
|  | NestedNameSpecifier * | NNS
| ) |  |
| static

Definition at line 621 of file USRGeneration.cpp.